/* Templates ******************************************************************

C++ untersttzt:

* objektorientierte Programmierung (Vererbung, Polymorphie)
* generische Programmierung (Templates), d.h. Abstraktion der Algorithmen
  von Datentypen

Die Standard Template Library (dazu spter) stellt typische Datenstrukturen
und Algorithmen abstrakt mit Hilfe von Templates bereit. Java lst das
durch besondere Objekte. Die Lsung von C++ ist etwas schlanker, aber
nicht so leicht zu verstehen.

*/

// erst mal eine harmlose Klasse
class DoubleArray
{
    private:
    int anzahl;
    double* speicher;

    public:
    DoubleArray(int n) :
    anzahl(n)
    {
        speicher = new double[n];
    }

    void setze (int wo, double wert)
    {
        speicher[wo] = wert;
    }

    double lese (int wo)
    {
        return speicher[wo];
    }
};

// jetzt abstrakt formuliert
template<class T> // Fr T kann spter ein beliebiger Typname eingesetzt werden,
                  // wenn der betreffende Typ die benutzten Methoden etc. beherrscht.
class Array
{
    private:
    int anzahl;
    T* speicher;

    public:
    Array(int n) :
    anzahl(n)
    {
        speicher = new T[n];
    }

    void setze (int wo, T wert)
    {
        speicher[wo] = wert;
    }

    T lese (int wo)
    {
        return speicher[wo];
    }
};

class Testklasse
{
    private:
    int x;
};

int main(int argc, char* (argv[]) )
{
    DoubleArray a(42);
    a.setze(13,7);

    Array<double> b(42); // baut die Klasse mit T = double zusammen
    b.setze(13,7);

    Array<Testklasse> d(42); // baut die Klasse mit T = Testklasse zusammen
    Testklasse c;
    d.setze(13,c);

    return 0;
}


