/* Die C++-Standardbibliothek **********************************************

Deren Datentypen, Funktionen und Templates werden per Header-Include zugnglich.

<ctype.h>, <limits.h>, <math.h>, <stdio.h>, <string.h>, <time.h> und andere
sind aus Kompabilittsgrnden zu C dabei.

In C++ gibt es alternativ die neuen C-Header, die im Namespace std leben:
<cctype>, <climits>, <cmath>, <cstdio>, <cstring>, <ctime> etc.           */

// Hauptschlich braucht man davon nur noch <cmath> :

#include <cmath>
using namespace std;

double a = sin(0.2456);

/* Einen groen Teil der C++-Standardbibliothek macht die Standard Template Library
(STL) aus -- eine Sammlung generischer Datenstrukturen und Algorithmen (Suchen, Sortieren ...) */

// Beispiel: Vector-Template

#include <vector>
#include <stdexcept>
#include <iostream>
using namespace std;

int main (int argc, char* (argv[]) )
{
    double x;
    vector<double> a;
    a.insert(a.end(), 5, 3.14); // fnfmal 3.14 einfgen
    a[3] = 7;
    x = a[4];
    x = a[42]; // keine berprfung der Grenzen bei []

    /*  Dev-C++ kann anders als Microsoft Visual C++ noch kein "at" fr "vector".
    a.at(3) = 7;
    x = a.at(4);
    try
    {
        a.at(42) = 4; // berprfung der Grenzen bei at( )
    }
    catch(out_of_range e)
    {
        cout << e.what() << endl;
    }
    try
    {
        x = a.at(42);
    }
    catch(out_of_range e)
    {
        cout << e.what() << endl;
    }
    */

    return 0;
}

/* Auerdem in der C++-Standardbibliothek: <iostream>, <string> etc.

string ist nicht fr sich eine Klasse, sondern so definiert:
typedef basic_string<char> string;
Man kann deshalb auch mit 2-Byte-Zeichensystemen arbeiten etc. */

